"""initial script

Revision ID: a819278f5f36
Revises:
Create Date: 2022-02-09 16:13:09.374152+01:00

"""
import sqlalchemy as sa
from alembic import op
from alembic_utils.pg_function import PGFunction
from sqlalchemy.dialects import postgresql
from sqlalchemy.schema import CreateSequence, Sequence

# revision identifiers, used by Alembic.
revision = "a819278f5f36"
down_revision = None
branch_labels = None
depends_on = None


def upgrade():

    # ### commands auto generated by Alembic - please adjust! ###
    op.execute(CreateSequence(Sequence("payment_id_seq")))  # type: ignore

    public_payment_generate_id = PGFunction(
        schema="public",
        signature="payment_generate_id()",
        definition="RETURNS varchar\n        LANGUAGE plpgsql\n        AS "
        "$function$\n            DECLARE\n            v_result      varchar "
        ":= 'PAY-';\n            value_numeric numeric;\n            begin\n"
        "                SELECT nextval('\"payment_id_seq\"') INTO "
        "value_numeric;\n                IF value_numeric > 9999 THEN\n       "
        "             v_result := v_result || value_numeric;\n               "
        " ELSE\n                    v_result := v_result || "
        "to_char(value_numeric, 'FM0000');\n                END IF;\n       "
        "         return v_result;\n            END;\n        $function$",
    )
    op.create_entity(public_payment_generate_id)  # type: ignore

    op.create_table(
        "payment",
        sa.Column("sid", sa.Integer(), nullable=False),
        sa.Column(
            "id",
            sa.String(),
            server_default=sa.text("payment_generate_id()"),
            nullable=False,
        ),
        sa.Column(
            "uuid",
            postgresql.UUID(as_uuid=True),
            server_default=sa.text("gen_random_uuid()"),
            nullable=False,
        ),
        sa.Column("order_number", sa.String(), nullable=True),
        sa.Column("amount", sa.String(), nullable=True),
        sa.Column("currency", sa.String(), nullable=True),
        sa.Column("description", sa.String(), nullable=True),
        sa.PrimaryKeyConstraint("sid"),
        sa.UniqueConstraint("order_number"),
        sa.UniqueConstraint("uuid"),
    )
    op.create_index(op.f("ix_payment_id"), "payment", ["id"], unique=True)
    op.create_index(op.f("ix_payment_sid"), "payment", ["sid"], unique=False)
    op.create_table(
        "payment_state",
        sa.Column("sid", sa.Integer(), nullable=False),
        sa.Column(
            "uuid",
            postgresql.UUID(as_uuid=True),
            server_default=sa.text("gen_random_uuid()"),
            nullable=False,
        ),
        sa.Column("payment_id", sa.Integer(), nullable=False),
        sa.Column("code", sa.String(), nullable=True),
        sa.Column("message", sa.String(), nullable=True),
        sa.Column("set_date", sa.DateTime(), nullable=True),
        sa.ForeignKeyConstraint(
            ["payment_id"],
            ["payment.sid"],
        ),
        sa.PrimaryKeyConstraint("sid"),
        sa.UniqueConstraint("uuid"),
    )
    op.create_index(op.f("ix_payment_state_code"), "payment_state", ["code"], unique=False)
    op.create_index(
        op.f("ix_payment_state_payment_id"),
        "payment_state",
        ["payment_id"],
        unique=False,
    )
    op.create_index(op.f("ix_payment_state_sid"), "payment_state", ["sid"], unique=False)

    op.execute(CreateSequence(Sequence("setting_id_seq")))  # type: ignore
    setting_generate_id = PGFunction(
        schema="public",
        signature="setting_generate_id()",
        definition="RETURNS varchar\n        LANGUAGE plpgsql\n        "
        "AS $function$\n            DECLARE\n            v_result      "
        "varchar := 'SET-';\n            value_numeric numeric;\n      "
        '      begin\n                SELECT nextval(\'"setting_id_seq"'
        "') INTO value_numeric;\n                IF value_numeric > 9999"
        " THEN\n                    v_result := v_result || "
        "value_numeric;\n                ELSE\n                   "
        " v_result := v_result || to_char(value_numeric, 'FM0000');\n   "
        "             END IF;\n                return v_result;\n        "
        "    END;\n        $function$",
    )
    op.create_entity(setting_generate_id)  # type: ignore

    op.create_table(
        "setting",
        sa.Column("sid", sa.Integer(), nullable=False),
        sa.Column(
            "id", sa.String(), server_default=sa.text("setting_generate_id()"), nullable=False
        ),
        sa.Column(
            "uuid",
            postgresql.UUID(as_uuid=True),
            server_default=sa.text("gen_random_uuid()"),
            nullable=False,
        ),
        sa.Column("name", sa.String(), nullable=True),
        sa.Column("value", sa.String(), nullable=True),
        sa.Column("description", sa.String(), nullable=True),
        sa.PrimaryKeyConstraint("sid"),
        sa.UniqueConstraint("uuid"),
    )
    op.create_index(op.f("ix_setting_id"), "setting", ["id"], unique=True)
    op.create_index(op.f("ix_setting_name"), "setting", ["name"], unique=False)
    op.create_index(op.f("ix_setting_sid"), "setting", ["sid"], unique=False)

    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###

    public_payment_generate_id = PGFunction(
        schema="public",
        signature="payment_generate_id()",
        definition="RETURNS varchar\n        LANGUAGE plpgsql\n        "
        "AS $function$\n            DECLARE\n            v_result      "
        "varchar := 'SET-';\n            value_numeric numeric;\n      "
        '      begin\n                SELECT nextval(\'"payment_id_seq"'
        "') INTO value_numeric;\n                IF value_numeric > 9999"
        " THEN\n                    v_result := v_result || "
        "value_numeric;\n                ELSE\n                   "
        " v_result := v_result || to_char(value_numeric, 'FM0000');\n   "
        "             END IF;\n                return v_result;\n        "
        "    END;\n        $function$",
    )
    op.drop_entity(public_payment_generate_id)  # type: ignore

    op.drop_index(op.f("ix_payment_state_sid"), table_name="payment_state")
    op.drop_index(op.f("ix_payment_state_payment_id"), table_name="payment_state")
    op.drop_index(op.f("ix_payment_state_code"), table_name="payment_state")
    op.drop_table("payment_state")
    op.drop_index(op.f("ix_payment_sid"), table_name="payment")
    op.drop_index(op.f("ix_payment_id"), table_name="payment")
    op.drop_table("payment")

    op.drop_index(op.f("ix_setting_sid"), table_name="setting")
    op.drop_index(op.f("ix_setting_name"), table_name="setting")
    op.drop_index(op.f("ix_setting_id"), table_name="setting")
    op.drop_table("setting")
    # ### end Alembic commands ###
